Ginkgo: gko::batch::EnableBatchLinOp< ConcreteBatchLinOp, PolymorphicBase > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::batch::EnableBatchLinOp< ConcreteBatchLinOp, PolymorphicBase > Class Template Reference
BatchLinOp

The EnableBatchLinOp mixin can be used to provide sensible default implementations of the majority of the BatchLinOp and PolymorphicObject interface. More...

`#include <ginkgo/core/base/batch_lin_op.hpp>`

Inheritance diagram for gko::batch::EnableBatchLinOp< ConcreteBatchLinOp, PolymorphicBase >:
[legend]
Collaboration diagram for gko::batch::EnableBatchLinOp< ConcreteBatchLinOp, PolymorphicBase >:
[legend]

## Additional Inherited Members
Public Types inherited from gko::EnablePolymorphicAssignment< ConcreteBatchLinOp >
using | result_type
Public Member Functions inherited from gko::EnablePolymorphicAssignment< ConcreteBatchLinOp >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override

## Detailed Description

template<typename ConcreteBatchLinOp, typename PolymorphicBase = BatchLinOp>
class gko::batch::EnableBatchLinOp< ConcreteBatchLinOp, PolymorphicBase >

The EnableBatchLinOp mixin can be used to provide sensible default implementations of the majority of the BatchLinOp and PolymorphicObject interface.

The goal of the mixin is to facilitate the development of new BatchLinOp, by enabling the implementers to focus on the important parts of their operator, while the library takes care of generating the trivial utility functions. The mixin will provide default implementations for the entire PolymorphicObject interface, including a default implementation of copy_from between objects of the new BatchLinOp type.

Implementers of new BatchLinOps are required to specify only the following aspects:

1. Creation of the BatchLinOp: This can be facilitated via either EnableCreateMethod mixin (used mostly for matrix formats), or GKO_ENABLE_BATCH_LIN_OP_FACTORY macro (used for operators created from other operators, like preconditioners and solvers).

Template Parameters

  ConcreteBatchLinOp | the concrete BatchLinOp which is being implemented [CRTP parameter]
  PolymorphicBase | parent of ConcreteBatchLinOp in the polymorphic hierarchy, has to be a subclass of BatchLinOp

The documentation for this class was generated from the following file:

- ginkgo/core/base/batch_lin_op.hpp